HDU 1253 胜利大逃亡(BFS)

题目链接

Problem Description
Ignatius被魔王抓走了,有一天魔王出差去了,这可是Ignatius逃亡的好机会.
魔王住在一个城堡里,城堡是一个A*B*C的立方体,可以被表示成A个B*C的矩阵,刚开始Ignatius被关在(0,0,0)的位置,离开城堡的门在(A-1,B-1,C-1)的位置,现在知道魔王将在T分钟后回到城堡,Ignatius每分钟能从一个坐标走到相邻的六个坐标中的其中一个.现在给你城堡的地图,请你计算出Ignatius能否在魔王回来前离开城堡(只要走到出口就算离开城堡,如果走到出口的时候魔王刚好回来也算逃亡成功),如果可以请输出需要多少分钟才能离开,如果不能则输出-1.

 
Input
输入数据的第一行是一个正整数K,表明测试数据的数量.每组测试数据的第一行是四个正整数A,B,C和T(1<=A,B,C<=50,1<=T<=1000),它们分别代表城堡的大小和魔王回来的时间.然后是A块输入数据(先是第0块,然后是第1块,第2块......),每块输入数据有B行,每行有C个正整数,代表迷宫的布局,其中0代表路,1代表墙.(如果对输入描述不清楚,可以参考Sample Input中的迷宫描述,它表示的就是上图中的迷宫)

特别注意:本题的测试数据非常大,请使用scanf输入,我不能保证使用cin能不超时.在本OJ上请使用Visual C++提交.
 
Output
对于每组测试数据,如果Ignatius能够在魔王回来前离开城堡,那么请输出他最少需要多少分钟,否则输出-1.
 
Sample Input
1
3 3 4 20
0 1 1 1
0 0 1 1
0 1 1 1
1 1 1 1
1 0 0 1
0 1 1 1
0 0 0 0
0 1 1 0
0 1 1 0
 
Sample Output
11

 题解:看起来很复杂,其实还是一个迷宫,因为问的是最少需要多少时间,所以用BFS。三维数组跟二维数组没有什么区别,只是dir数组开得有点不同。

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <stack>
#include <queue>
#include <algorithm>
#include <cmath>
#include <map>
using namespace std;
//#define LOCAL
int mp[55][55][55];
bool vis[55][55][55];
int N,A,B,C,T;
struct node
{
    node(int a,int b,int c,int d)
    {x=a,y=b,z=c,time=d;}
    int x,y,z;
    int time;
};
int dir[6][3]={{1,0,0},{-1,0,0},{0,0,1},{0,0,-1},{0,1,0},{0,-1,0}};
bool check(int x,int y,int z)
{
    if(x>=0&&y>=0&&z>=0&&x<A&&y<B&&z<C&&mp[x][y][z]==0)
    return 1;
    return 0;
}
int bfs(int t)
{
    node st(0,0,0,0),ed(0,0,0,0);
    queue<node>q;
    while(!q.empty())q.pop();
    memset(vis,0,sizeof vis);
    vis[0][0][0]=1;
    q.push(st);
    while(!q.empty())
    {
        st=q.front();
        q.pop();
        if(st.time>t)return -1;
        if(st.x==A-1&&st.y==B-1&&st.z==C-1&&st.time<=T)return st.time;
        for(int i=0;i<6;i++)
        {
            ed.x=st.x+dir[i][0];
            ed.y=st.y+dir[i][1];
            ed.z=st.z+dir[i][2];
            if(check(ed.x,ed.y,ed.z)&&!vis[ed.x][ed.y][ed.z])
            {
                vis[ed.x][ed.y][ed.z]=true;
                ed.time=st.time+1;
                if(abs(ed.x-A+1)+abs(ed.y-B+1)+abs(ed.z-C+1)+ed.time>T)continue;
                q.push(ed);
            }
        }
    }
    return -1;
}
int main()
{
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif // LOCAL
    //Start
    scanf("%d",&N);
    while(N--)
    {
        scanf("%d%d%d%d",&A,&B,&C,&T);
        memset(mp,0,sizeof mp);
        for(int i=0; i<A; i++)
        for(int j=0; j<B; j++)
        for(int k=0; k<C; k++)
        scanf("%d",&mp[i][j][k]);
        printf("%d
",bfs(T));
    }
    return 0;
}
原文地址:https://www.cnblogs.com/gpsx/p/5167681.html